
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <termios.h>

// Variables
char *device0 = "/dev/ttyS0";
char *device1 = "/dev/ttyS1";
char *device2 = "/dev/ttyS2";
char *device3 = "/dev/ttyS3";
int fd;
struct termios tty;
char c;
int noct;
unsigned char cks;
unsigned char header;
unsigned char msb;
unsigned char lsb;
unsigned int timout;
unsigned char restart;
unsigned char firstrec;
float cps;
int nback;
int nminute;
int nhour;
float totminutes;
float avg;
float avgh;
char reply[11];

FILE *minut;
FILE *hour;

// Prototypes
void receive(void);
void record(void);
void opcom(void);

int main(int argc, char *argv[])
	{
	restart=1;
	printf("\nwww.vptec.narod.ru - Serial data logger for GM counter :\n");
	printf("To be used with serial data connection GM counter described on the web site\n\n");
	printf("0 - Select ttyS0\n1 - Select ttyS1\n2 - Select ttyS2\n3 - Select ttyS3\nQ - Abort\n\n");
	printf("Enter selection: ");
	scanf("%10s",reply);
	switch (reply[0])
		{
		case '0':
		break;
		case '1':
		strcpy(device0,device1);
		break;
		case '2':
		strcpy(device0,device2);
		break;
		case '3':
		strcpy(device0,device3);
		break;
		default:
		restart=0;
		break;
		}
	while (restart==1)
		{
		noct=0;
		cks=0;
		header=0;
		msb=0;
		lsb=0;
		timout=0;
		cps=0;
		nback=0;
		nminute=0;
		nhour=0;
		totminutes=0;
		avg=0;
		avgh=0;
		c=0;
		timout=0;
		firstrec=0;
		printf("\nPress 'G' + enter when ready to start, or 'Q' + enter to quit... ");
		scanf("%2s",reply);
		if ((reply[0]!='g')&&(reply[0]!='G'))
			{
			exit(0);
			}
		printf("\nRunning - Shut GM counter down or disconnect serial link to stop...\n\n");
		opcom();
		if(!fd)
			{
			exit(0);
			}
		minut=fopen("minutes.txt","w");
		if(minut)
			{
			printf("\n\nWaiting for data (12s time-out)...\n");
			fprintf(minut,"Averaged values spaced of 1 minute:\n");
			}
		else
			{
			printf("Error while opening minutes.txt !\n\n");
			close(fd);
			exit(0);
			}
		hour=fopen("hourly.txt","w");
		if(hour)
			{
			fprintf(hour,"Averaged values spaced of 1 hour:\n");
			}
		else
			{
			printf("Error while opening hourly.txt !\n\n");
			fclose(minut);
			close(fd);
			exit(0);
			}
		while ((timout<12000)&&(totminutes<65000))
			{
			timout+=1;
			usleep(1000);
			receive();
			}
		close(fd);
		fclose(minut);
		fclose(hour);
		if (firstrec==0)
			{
			printf("\nReception timed-out !\n\n");
			}
		else
			{
			printf("\nRecording stopped - Output results written to minute.txt and hourly.txt\n\n");
			}
		printf("Start a new record (y/n) ? ");
		scanf("%2s",reply);
		printf("\n\n");
		if((reply[0]!='y')&&(reply[0]!='Y'))
			{
			restart=0;
			}
		}
	}

void receive(void)
	{
	if(read(fd,&c,1))
		{
		switch (noct)
			{
			case 0:
			header=(unsigned char)c;
			break;
			case 1:
			lsb=(unsigned char)c;
			break;
			case 2:
			msb=(unsigned char)c;
			break;
			case 3:
			cks=header+msb+lsb;
			if((header==(unsigned char)0xFF)&&(cks==(unsigned char)c))
				{
				record();
				firstrec=1;
				timout=0;
				noct=0;
				}
			else
				{
				header=lsb;
				lsb=msb;
				msb=(unsigned char)c;
				noct-=1;
				}
			break;
			}
		noct+=1;
		timout=0;
		}
	}

void record(void)
	{
	if(firstrec==1)
		{
		cps=0.1*(float)((((unsigned int)msb)<<8)+(unsigned int)lsb);
		printf("%c[%cACPS at t0 + %f minute(s): %f            \n",0x1B,1,(totminutes+((float)nback)/6),cps);
		}
	else
		{
		printf("%c[%cAReception started !                      \n",0x1B,1);
		}
	avg+=cps;
	nback+=1;
	if (nback==6)
		{
		nback=0;
		avg/=6;
		if(nminute>9)
			{
			fprintf(minut,"%d:%d : %f cps\n",nhour,nminute,avg);
			}
		else
			{
			fprintf(minut,"%d:0%d : %f cps\n",nhour,nminute,avg);
			}
		avgh+=avg;
		avg=0;
		nminute+=1;
		totminutes+=1;
		if(nminute==60)
			{
			nminute=0;
			nhour+=1;
			avgh/=60;
			fprintf(hour,"%d:00 : %f cps\n",nhour,avg);
			avgh=0;
			}
		}
	}

void opcom(void)
	{
	printf("Opening %s ...\n\n",device0);
	fd = open(device0,O_RDWR | O_NOCTTY | O_NONBLOCK);
	if(!fd)
		{
		printf("Com Port Opening Failed !\n");
		return;
		}
	tty.c_cflag = B1200;			/* 1200 bauds */
	tty.c_cflag |= CLOCAL;			/* ignore modem control lines */
	tty.c_cflag |= CREAD;			/* enable receiver */
	tty.c_cflag |= CS8;			/* use 8 data bits */
	tty.c_cflag |= CSTOPB;			/* 2 stop bits */
	tty.c_cflag &= ~PARENB;			/* disable parity */
	//tty.c_cflag |= PARODD;		/* use odd parity */
	tty.c_cflag &= ~CRTSCTS;		/* do not use RTS and CTS handshake */
	tcsetattr(fd,TCSANOW,&tty);
	printf("Port opened successfully\n");
	}



