
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <termios.h>

// Variables
char *device0 = "/dev/ttyS0";
char *device1 = "/dev/ttyS1";
char *device2 = "/dev/ttyS2";
char *device3 = "/dev/ttyS3";
int fd;
struct termios tty;
char c;
float coeff;
float totcps;
float backcps;
float netcps;
float cps;
float avg;
float avgh;
int nacq;
int noct;
unsigned char cks;
unsigned char header;
unsigned char msb;
unsigned char lsb;
unsigned char restart;
unsigned int timout;
float mass;
char reply[11];

// Prototypes
void receive(void);
void record(void);
void opcom(void);

int main(int argc, char *argv[])
	{
	restart=1;
	coeff=0;
	printf("\nLow level radioactivity net count rate processing - www.vptec.narod.ru\n");
	printf("To be used with serial data connection GM counter described on the web site\n\n");
	printf("0 - Select ttyS0\n1 - Select ttyS1\n2 - Select ttyS2\n3 - Select ttyS3\nQ - Abort\n\n");
	printf("Enter selection: ");
	scanf("%10s",reply);
	switch (reply[0])
		{
		case '0':
		break;
		case '1':
		strcpy(device0,device1);
		break;
		case '2':
		strcpy(device0,device2);
		break;
		case '3':
		strcpy(device0,device3);
		break;
		default:
		restart=0;
		break;
		}
	while (restart==1)
		{
		totcps=0;
		backcps=0;
		netcps=0;
		avg=0;
		avgh=0;
		nacq=0;
		noct=0;
		cks=0;
		header=0;
		msb=0;
		lsb=0;
		cps=0;
		c=0;
		timout=0;
		printf("\nPress 'G' + enter when ready to measure background, or 'Q' + enter to quit... ");
		scanf("%2s",reply);
		if ((reply[0]!='g')&&(reply[0]!='G'))
			{
			exit(0);
			}
		opcom();
		if(!fd)
			{
			exit(0);
			}
		printf("\n\nWaiting for data (12s time-out)...\n");
		while ((nacq<19)&&(timout<12000))
			{
			timout+=1;
			usleep(1000);
			receive();
			}
		close(fd);
		if (nacq<19)
			{
			printf("\nReception timed-out !\n\n");
			exit(0);
			}
		backcps=cps;
		printf("\nPress 'G' + enter when ready to measure background + sample, or 'Q' + enter to quit...  ");
		scanf("%2s",reply);
		if ((reply[0]!='g')&&(reply[0]!='G'))
			{
			exit(0);
			}
		opcom();
		if(!fd)
			{
			exit(0);
			}
		nacq = 0;
		noct = 0;
		cks = 0;
		header = 0;
		msb = 0;
		lsb = 0;
		cps = 0;
		printf("\n\nWaiting for data (12s time-out)...\n");
		while ((nacq<19)&&(timout<12000))
			{
			timout+=1;
			usleep(1000);
			receive();
			}
		close(fd);
		if (nacq<19)
			{
			printf("\nReception timed-out !\n\n");
			exit(0);
			}
		totcps=cps;
		printf("\n\n*********************************************");
		printf("\n\nFinal results:\n\n");
		printf("- Background: %f counts over 3 minutes = %f cpm\n",backcps,backcps/3);
		printf("- Sample + Background: %f counts over 3 minutes = %f cpm\n",totcps,totcps/3);
		netcps=(totcps-backcps)/180;
		printf("- Net count rate: %f cpm = %f cps\n\n",(60*netcps),netcps);
		if (netcps<=0)
			{
			printf("Sample does not add radioactivity but shields environmental radiation !\nMeasurement setup is not adapted\n");
			}
		else
			{
			if ((netcps/totcps)<0.00011)
				{
				printf("Detected radioactivity versus background is very low\nMeasurements are not significant\n");
				}
			else
				{
				printf("Convert this result to a sample activity level (y/n) ? ");
				scanf("%2s",reply);
				if((reply[0]=='Y')||(reply[0]=='y'))
					{
					if(coeff==0)
						{
						while(coeff==0)
							{
							printf("\nEnter coefficient of the used GM tube in Imp/Bq.s : ");
							scanf("%10s",reply);
							sscanf(reply,"%f",&coeff);
							}
						}
					else
						{
						printf("Coefficient of the used GM tube in Imp/Bq.s : %f\n",coeff);
						}
					mass=0;
					while(mass<=0)
						{
						printf("\nMass of the sample in Kg : ");
						scanf("%10s",reply);
						sscanf(reply,"%f",&mass);
						}
					printf("\n\nSample activity level: %f Bq/Kg\n\n",(netcps/(coeff*mass)));
					}
				}
			}
		printf("Start a new measurement (y/n) ? ");
		scanf("%2s",reply);
		printf("\n\n");
		if((reply[0]!='y')&&(reply[0]!='Y'))
			{
			restart=0;
			}
		}
	}

void receive(void)
	{
	if(read(fd,&c,1))
		{
		switch (noct)
			{
			case 0:
			header=(unsigned char)c;
			break;
			case 1:
			lsb=(unsigned char)c;
			break;
			case 2:
			msb=(unsigned char)c;
			break;
			case 3:
			cks=header+msb+lsb;
			if((header==(unsigned char)0xFF)&&(cks==(unsigned char)c))
				{
				record();
				timout=0;
				noct=0;
				}
			else
				{
				header=lsb;
				lsb=msb;
				msb=(unsigned char)c;
				noct-=1;
				}
			break;
			}
		noct+=1;
		timout=0;
		}
	}

void record(void)
	{
	nacq+=1;
	if(nacq>1)
		{
		cps+=(float)((((unsigned int)msb)<<8)+(unsigned int)lsb);
		printf("%c[%cACounts over %d seconds: %f counts        \n",0x1B,1,(10*(nacq-1)),cps);
		}
	else
		{
		printf("%c[%cAReception started !                      \n",0x1B,1);
		}
	}

void opcom(void)
	{
	printf("Opening %s ...\n\n",device0);
	fd = open(device0,O_RDWR | O_NOCTTY | O_NONBLOCK);
	if(!fd)
		{
		printf("Com Port Opening Failed !\n");
		return;
		}
	tty.c_cflag = B1200;			/* 1200 bauds */
	tty.c_cflag |= CLOCAL;			/* ignore modem control lines */
	tty.c_cflag |= CREAD;			/* enable receiver */
	tty.c_cflag |= CS8;			/* use 8 data bits */
	tty.c_cflag |= CSTOPB;			/* 2 stop bits */
	tty.c_cflag &= ~PARENB;			/* disable parity */
	//tty.c_cflag |= PARODD;		/* use odd parity */
	tty.c_cflag &= ~CRTSCTS;		/* do not use RTS and CTS handshake */
	tcsetattr(fd,TCSANOW,&tty);
	printf("Port opened successfully\n");
	}



